<?php
if (!defined('WP_UNINSTALL_PLUGIN')) {
    exit; // Exit if accessed directly
}

function on_page_seo_uninstaller() {
    // Load WP Filesystem API
    if ( ! function_exists('WP_Filesystem') ) {
        require_once ABSPATH . 'wp-admin/includes/file.php';
    }

    global $wp_filesystem;
    WP_Filesystem();

    $robfile = ABSPATH . 'robots.txt';
    $sitemapfile = ABSPATH . 'sitemap.xml';

    // Delete files safely using WP_Filesystem
    if ( $wp_filesystem->exists($robfile) ) {
        $wp_filesystem->delete($robfile);
    }

    if ( $wp_filesystem->exists($sitemapfile) ) {
        $wp_filesystem->delete($sitemapfile);
    }
}

on_page_seo_uninstaller();
